/*
========================================================================

                           D O O M  R e t r o
         The classic, refined DOOM source port. For Windows PC.

========================================================================

  Copyright © 1993-2021 by id Software LLC, a ZeniMax Media company.
  Copyright © 2013-2021 by Brad Harding <mailto:brad@doomretro.com>.

  DOOM Retro is a fork of Chocolate DOOM. For a list of credits, see
  <https://github.com/bradharding/doomretro/wiki/CREDITS>.

  This file is a part of DOOM Retro.

  DOOM Retro is free software: you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the
  Free Software Foundation, either version 3 of the License, or (at your
  option) any later version.

  DOOM Retro is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with DOOM Retro. If not, see <https://www.gnu.org/licenses/>.

  DOOM is a registered trademark of id Software LLC, a ZeniMax Media
  company, in the US and/or other countries, and is used without
  permission. All other trademarks are the property of their respective
  holders. DOOM Retro is in no way affiliated with nor endorsed by
  id Software.

========================================================================
*/

#if !defined(__M_CONTROLS_H__)
#define __M_CONTROLS_H__

#include "doomkeys.h"

extern int  keyboardalwaysrun;
extern int  keyboardautomap;
extern int  keyboardautomapclearmark;
extern int  keyboardautomapfollowmode;
extern int  keyboardautomapgrid;
extern int  keyboardautomapmark;
extern int  keyboardautomapmaxzoom;
extern int  keyboardautomaprotatemode;
extern int  keyboardautomapzoomin;
extern int  keyboardautomapzoomout;
extern int  keyboardback;
extern int  keyboardback2;
extern int  keyboardconsole;
extern int  keyboardfire;
extern int  keyboardforward;
extern int  keyboardforward2;
extern int  keyboardjump;
extern int  keyboardleft;
extern int  keyboardmenu;
extern int  keyboardmouselook;
extern int  keyboardnextweapon;
extern int  keyboardprevweapon;
extern int  keyboardright;
extern int  keyboardrun;
extern int  keyboardscreenshot;
extern int  keyboardstrafe;
extern int  keyboardstrafeleft2;
extern int  keyboardstrafeleft;
extern int  keyboardstraferight2;
extern int  keyboardstraferight;
extern int  keyboarduse;
extern int  keyboarduse2;
extern int  keyboardweapon1;
extern int  keyboardweapon2;
extern int  keyboardweapon3;
extern int  keyboardweapon4;
extern int  keyboardweapon5;
extern int  keyboardweapon6;
extern int  keyboardweapon7;

extern int  mousefire;
extern int  mouseforward;
extern int  mousejump;
extern int  mousemouselook;
extern int  mousenextweapon;
extern int  mouseprevweapon;
extern int  mouserun;
extern int  mousescreenshot;
extern int  mousestrafe;
extern int  mouseuse;
extern int  mouseweapon1;
extern int  mouseweapon2;
extern int  mouseweapon3;
extern int  mouseweapon4;
extern int  mouseweapon5;
extern int  mouseweapon6;
extern int  mouseweapon7;

extern int  gamepadalwaysrun;
extern int  gamepadautomap;
extern int  gamepadautomapclearmark;
extern int  gamepadautomapfollowmode;
extern int  gamepadautomapgrid;
extern int  gamepadautomapmark;
extern int  gamepadautomapmaxzoom;
extern int  gamepadautomaprotatemode;
extern int  gamepadautomapzoomin;
extern int  gamepadautomapzoomout;
extern int  gamepadback;
extern int  gamepadconsole;
extern int  gamepadfire;
extern int  gamepadforward;
extern int  gamepadjump;
extern int  gamepadleft;
extern int  gamepadmenu;
extern int  gamepadmouselook;
extern int  gamepadnextweapon;
extern int  gamepadprevweapon;
extern int  gamepadright;
extern int  gamepadrun;
extern int  gamepadstrafe;
extern int  gamepadstrafeleft;
extern int  gamepadstraferight;
extern int  gamepaduse;
extern int  gamepaduse2;
extern int  gamepadweapon1;
extern int  gamepadweapon2;
extern int  gamepadweapon3;
extern int  gamepadweapon4;
extern int  gamepadweapon5;
extern int  gamepadweapon6;
extern int  gamepadweapon7;

#endif
